VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMulDecode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Decode mul project by Fallout (roman3k@mail.ru)"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' ************************************* '
' *Create by Fallout (roman3k@mail.ru)* '
' *     Do not remove this header     * '
' ************************************* '
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Attribute SetPixel.VB_UserMemId = 1879244856

Private Declare Function RLIShiftRight Lib "ntdll" Alias "RtlLargeIntegerShiftRight" _
        (ByVal Val1 As Long, ByVal Val2 As Long, ByVal ShiftCount As Long) As LARGEINT
Attribute RLIShiftRight.VB_UserMemId = 1879245260

Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Attribute CreateCompatibleBitmap.VB_UserMemId = 1879244888
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Attribute CreateCompatibleDC.VB_UserMemId = 1879244932
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Attribute SelectObject.VB_UserMemId = 1879244972
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Attribute DeleteDC.VB_UserMemId = 1879245008
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Attribute DeleteObject.VB_UserMemId = 1879245040
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Attribute GetDC.VB_UserMemId = 1879245076
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Attribute FillRect.VB_UserMemId = 1879245104
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Attribute SetRect.VB_UserMemId = 1879245136
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Attribute CreateSolidBrush.VB_UserMemId = 1879245164

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type LARGEINT
    Val1 As Long
    Val2 As Long
End Type

Private hDCTmp As Long
Private hBMTmp As Long
Private hBrush As Long

Private mOffset As Long
Private mSize As Long
Private mExtra As Long

Private X As Integer, Y As Integer
Private i As Integer

Private lookUpTable() As Long
Private palette(0 To &H100 - 1) As Integer
Private frameCount As Long

Private centerX As Integer
Private centerY As Integer

Private mWidth As Integer
Private mHeight As Integer

Private loheader As Integer
Private hiheader As Integer

Private palettePixels() As Byte

Private lineNum As Byte
Private prevNum As Byte
Private xRun As Integer

Private mvarFilePath As String
Private mvarFilePathIdx As String

Public Property Let FilePath(ByVal vData As String)
    mvarFilePath = vData
End Property

Public Property Get FilePath() As String
    FilePath = mvarFilePath
End Property

Public Property Get WidhtInfo() As Integer
    WidhtInfo = mWidth
End Property

Public Property Get HeightInfo() As Integer
    HeightInfo = mHeight
End Property

Public Property Let FilePathIdx(ByVal vData As String)
    mvarFilePathIdx = vData
End Property

Public Property Get FilePathIdx() As String
    FilePathIdx = mvarFilePathIdx
End Property

Private Sub Clear_Dc()
    DeleteDC hDCTmp                ' clean up '
    DeleteObject hBMTmp
End Sub

Public Sub DecodeFileInfo(ByRef picHdc As Long, ByVal infId As Long)
    Dim fileNum As Integer, R As RECT
    fileNum = FreeFile()           ' get freefile num '

    If hDCTmp <> 0 Then Clear_Dc
    Open mvarFilePathIdx For Binary Access Read As fileNum
    Get fileNum, infId * 12 + 1, mOffset
    Get fileNum, Seek(fileNum), mSize
    Get fileNum, Seek(fileNum), mExtra
    Close fileNum
    fileNum = FreeFile()
    Open mvarFilePath For Binary As fileNum
    Get fileNum, mOffset + 1, palette()      ' read color palette             '
    Get fileNum, Seek(fileNum), frameCount   ' read number of animation frame '
    ReDim lookUpTable(0 To frameCount - 1)
    Get fileNum, Seek(fileNum), lookUpTable()   ' read offset on each frame '
    Get fileNum, (mOffset + 1) + lookUpTable(0) + &H200, centerX
    Get fileNum, Seek(fileNum), centerY
    Get fileNum, Seek(fileNum), mWidth
    Get fileNum, Seek(fileNum), mHeight
    ' create memory pool '
    hDCTmp = CreateCompatibleDC(GetDC(0))                        ' create a device context                   '
    hBMTmp = CreateCompatibleBitmap(GetDC(0), mWidth, mHeight)   ' create a bitmap                           '
    SelectObject hDCTmp, hBMTmp                                  ' select the bitmap into the device context '
    SetRect R, 0, 0, mWidth, mHeight                             ' set the rectangle's values                '
    hBrush = CreateSolidBrush(vbBlack)
    FillRect hDCTmp, R, hBrush     ' fill the rect with the your color '
    DeleteObject hBrush            ' delete our brush                  '
    ' end create '
    X = 0: Y = 0: prevNum = &HFF
    Do
        Get fileNum, Seek(fileNum), loheader
        Get fileNum, Seek(fileNum), hiheader
        If ((loheader = &H7FFF) And (hiheader = &H7FFF)) Then Exit Do
        xRun = loheader And &HFFF
        X = shr(hiheader, 6) And &H3FF
        lineNum = (loheader \ &H1000) And &HF
        If (hiheader And &H8000) Then
            X = X + centerX - &H400
        Else
            X = X + centerX
        End If
        If ((prevNum <> &HFF) And (lineNum <> prevNum)) Then Y = Y + 1
        prevNum = lineNum
        ReDim palettePixels(0 To xRun - 1)
        Get fileNum, Seek(fileNum), palettePixels()
        For i = 0 To xRun - 1
            Call SetPixel(hDCTmp, X + i, Y, Color16To32(palette(palettePixels(i))))
        Next i
    Loop
    Close fileNum
    picHdc = hDCTmp
End Sub

Private Sub Class_Terminate()
    Clear_Dc
End Sub

Private Function Color16To32(color16 As Integer) As Long   '  16   32   '
    Color16To32 = RGB(((((color16 And &H7C00) / &H400) / &H1F) * &HFF), ((((color16 And &H3E0) / &H20) / &H1F) * &HFF), (((color16 And &H1F) / &H1F) * &HFF))
End Function

Private Function shr(ByVal Value As Long, ByVal ShiftCount As Long) As Long
    Dim Result As LARGEINT
    Result = RLIShiftRight(Value, 0, ShiftCount)
    shr = Result.Val1
End Function

